> For the complete documentation index, see [llms.txt](https://docs.pagsmile.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.pagsmile.com/reference/payin/submit-a-payin/mexico/codi.md).

# CoDi

## Payin by CoDi

<mark style="color:green;">`POST`</mark> `https://gateway-test.pagsmile.com/trade/pay`

This endpoint allows you to submit a payin by CoDi in Mexico.

{% hint style="danger" %}
CoDi is temporarily unavailable starting from November, 2025.
{% endhint %}

#### Headers

| Name                                            | Type   | Description                                |
| ----------------------------------------------- | ------ | ------------------------------------------ |
| Content-Type<mark style="color:red;">\*</mark>  | string | application/json; chartset=UTF-8           |
| Authorization<mark style="color:red;">\*</mark> | string | Basic Base($app\_*id:$security\_*&#x6B;ey) |

#### Request Body

| Name                                                       | Type   | Description                                                                                         |
| ---------------------------------------------------------- | ------ | --------------------------------------------------------------------------------------------------- |
| app\_id<mark style="color:red;">\*</mark>                  | string | <p>created app's id at dashboard</p><p>- Max. 32 chars -</p>                                        |
| customer.phone                                             | string | User's phone                                                                                        |
| customer.email<mark style="color:red;">\*</mark>           | string | User's email                                                                                        |
| customer.identify.number<mark style="color:red;">\*</mark> | string | <p>User's identification number<br>- RFC: 13 chars, ex: MAMB780915969; CURP: 18 chars -</p>         |
| method<mark style="color:red;">\*</mark>                   | string | Fixed value: CoDi                                                                                   |
| out\_trade\_no<mark style="color:red;">\*</mark>           | string | <p>ID given by the merchant in their system<br>- Max. 64 chars -</p>                                |
| notify\_url<mark style="color:red;">\*</mark>              | string | Where Pagsmile will send notification to                                                            |
| customer.identify.type<mark style="color:red;">\*</mark>   | string | <p>User's identification type</p><p>- RFC or CURP -</p>                                             |
| customer.name<mark style="color:red;">\*</mark>            | string | User's name                                                                                         |
| timestamp<mark style="color:red;">\*</mark>                | string | <p>yyyy-MM-dd HH:mm:ss<br>- Max. 19 chars -</p>                                                     |
| subject<mark style="color:red;">\*</mark>                  | string | <p>payment reason or item title</p><p>- Max. 128 chars -</p>                                        |
| order\_amount<mark style="color:red;">\*</mark>            | string | <p>payment amount<br>- check <a href="/pages/DOtsCR24aIKlDGmsezwr#mexico">here</a> for limits -</p> |
| order\_currency<mark style="color:red;">\*</mark>          | string | Fixed value: MXN                                                                                    |
| content                                                    | string | <p>payment reason detail or item detail</p><p>- Max. 255 chars -</p>                                |
| buyer\_id<mark style="color:red;">\*</mark>                | string | merchant user's id                                                                                  |
| address.zip\_code                                          | string | <p>zip code<br>- 5 digits -</p>                                                                     |
| website\_url                                               | string | <p>merchant website URL</p><p>- Max. 128 chars -</p>                                                |
| address.street                                             | string | street                                                                                              |
| address.street\_number                                     | string | street number                                                                                       |
| address.city                                               | string | city                                                                                                |
| address.state                                              | string | state                                                                                               |
| return\_url                                                | string | Redirect to Merchant's url when user finished checkout                                              |

{% tabs %}
{% tab title="200 submit successfully" %}

```
{
    "code": "10000",
    "msg": "Success",
    "prepay_id":"QUVQM3ZrVHZhdGJU****VpK02mcHY1a1d23MVRDaz0=-D7a1a5B0",
    "trade_no": "2022010110293900084",
    "out_trade_no": "202201010354004",
    "web_url": "",
    "trade_status": "PROCESSING",
    "qr_code":"{\"TYP\":20,\"v\":{\"DEV\":\"00000161803500000000/0\"},\"ic\":{\"IDC\":\"2cee29d4ed\",\"SER\":7254764,\"ENC\":\"d6XHjV42clxs162KdoN+Md4yJlnoh3Rpj9L+/gM4QnqFt2I+qJrGIAIbi4oX743+xK7apETvIpn+IDQ2tbjTN8Zo4WiPwPaDBIndqrvEoZbixTFPvoqIU+Cb0YVrwR/BeZ2AcikYvNZjvU8SGT/4X4MmbOT/aubVvVse8//CNTCc****L0wG7E5cMSY2zXARRWLfkFSjwCt7xqjklPwxsV2Z0N25m0epbvXyhCr48w5rKTmmTIiSkJoBrQRHIJX45*****180BWsYs4nwNfQT65c//v2IfQxbb03NSwF*****hwpHkCszGzEO8xXHXNCQ/FjbNrcyT6bkSS0EK8L//AyX99oR4808V****FU+3lpL7xW6YBL+0Q30ogdFw==\"},\"CRY\":\"bPi7ICAIYZ+7klXLtfDvHdDSNa0dO0wazXtC9l8OaYM=\"}",
    "reference": "0000000",
}
```

{% endtab %}

{% tab title="400 duplicate out\_trade\_no" %}

```
{
    "code": "40002",
    "msg": "Business Failed",
    "sub_code": "duplicate-out_trade_no",
    "sub_msg": "out_trade_no is duplicate"
}
```

{% endtab %}
{% endtabs %}

{% hint style="info" %}
**User payment tips**

* Users only need to scan the QR code to finish the payment. QR code can be generated with **qr\_code** value.
  {% endhint %}

## Example

```
curl --location --request POST 'https://gateway-test.pagsmile.com/trade/pay' \
--header 'Authorization: Basic MTYyNTgyOTIxNDUzMTY2Mzg6UGFnc21pbGVfc2tfZDUwMWQ1ZGNkNTI5OGQ5N2MwNmUzYjI4YjA2OWZjZmY3NDU5ZjY2NzNiMjFjMTFlYTY3NDM5MDgzOTZkOTYxNQ==' \
--header 'Content-Type: application/json' \
--data-raw '{
    * "app_id": "162************38",
    * "out_trade_no": "202201010354004",
    * "method": "CoDi",
    * "order_amount": "12.01",
    * "order_currency": "MXN",
    * "subject": "trade pay test",
      "content": "trade pay test conent",
    * "notify_url": "http://merchant/callback/success",
      "return_url": "https://www.merchant.com",
    * "buyer_id": "buyer_0101_0001",
    * "timestamp": "2022-01-01 03:54:01",
      "timeout_express":"1c",
    * "customer" : {
    *     "identify": {
    *         "type": "RFC",
    *         "number": "MAMB780915969"
          },
    *     "name": "Test User Name",
    *     "email": "test@pagsmile.com"
      }
      }'
```

![Example of payment page](/files/LzQAcMc1mKpKGnwsAHOf)

{% hint style="info" %}
Note: **162\*\*\*\*\*\*\*\*\*\*\*\*38** is pagsmile's test app id for sandbox, and **MTYyNTgyOTIxNDUzMTY2Mzg6UGFnc21pbGVfc2tfZDUwMWQ1ZGNkNTI5OGQ5N2MwNmUzYjI4YjA2OWZjZmY3NDU5ZjY2NzNiMjFjMTFlYTY3NDM5MDgzOTZkOTYxNQ==** is authorization token associated with the test app id.
{% endhint %}

{% hint style="danger" %}
Please use your own **app\_id** and generate your own **authorization token** when testing.
{% endhint %}
